/*
 * Copy me if you can.
 * by 20h
 */

#include <u.h>
#include <libc.h>

char be[] =
	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

void
b64enc(int in, int out)
{
	char s[4], o[5];
	int l;

	memset(s, 0, 4);
	memset(o, 0, 5);

	while((l = read(in, s, 3)) > 0) {
		o[0] = be[(s[0] & 0xFF) >> 2 & 0xFF];
		o[1] = be[(((s[0] & 0xFF) & 3) << 4) | ((s[1] & 0xFF) >> 4)  & 0xFF];
		o[2] = be[(((s[1] & 0xFF) & 0xF) << 2) | ((s[2] & 0xFF) >> 6) & 0xFF];
		o[3] = be[(s[2] & 0xFF) & 0x3F & 0xFF];

		if(l < 3)
			o[3] = '=';
		if(l < 2)
			o[2] = '=';
		write(out, o, 4);

		memset(s, 0, 4);
		memset(o, 0, 5);
	}
}

void
b64dec(int in, int out)
{
	char bd[256], s[5], o[4];
	int l;

	l = -1;
	memset(bd, 0x80, 256);
	while(++l < strlen(be))
		bd[be[l]] = l;
	bd['='] = 0;

	memset(s, 0, 5);
	memset(o, 0, 4);

	while(read(in, s, 4) >= 4) {
		o[0] = ((bd[s[0] & 0xFF] & 0xFF) << 2) | ((bd[s[1] & 0xFF] & 0xFF) >> 4) & 0xFF;
		o[1] = ((bd[s[1] & 0xFF] & 0xFF) << 4) | ((bd[s[2] & 0xFF] & 0xFF) >> 2) & 0xFF;
		o[2] = ((bd[s[2] & 0xFF] & 0xFF) << 6) | bd[s[3] & 0xFF] & 0xFF;

		l = 3;
		if(s[3] == '=') {
			o[2] = '\0';
			l = 2;
		}
		if(s[2] == '=') {
			o[1] = '\0';
			l = 1;
		}
		write(out, o, l);

		memset(s, 0, 5);
		memset(o, 0, 4);
	}
}

void
usage(void)
{
	print("usage: [-d]\n");
	exits(0);
}

void
main(int argc, char *argv[])
{
	int dec;

	dec = 0;

	ARGBEGIN {
		case 'd':
			dec = 1;
			break;
		default:
			usage();
	} ARGEND;

	if(dec)
		b64dec(0, 1);
	else
		b64enc(0, 1);

	exits(0);
}
